WritableField< Data_T > Class Template Referenceabstract
Fields

`#include <Field.h>`

Inheritance diagram for WritableField< Data_T >:

## Classes

class | iterator

## Public Types

typedef WritableField< Data_T > | class_type
typedef boost::intrusive_ptr< WritableField > | Ptr
Public Types inherited from Field< Data_T >
typedef Field< Data_T > | class_type
typedef boost::intrusive_ptr< Field > | Ptr
typedef Data_T | value_type
| Allows us to reference the template class.
typedef std::vector< Ptr > | Vec
| This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.
Public Types inherited from FieldRes
typedef FieldRes | class_type
typedef boost::intrusive_ptr< FieldRes > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from FieldBase
typedef FieldBase | class_type
typedef boost::intrusive_ptr< FieldBase > | Ptr
Public Types inherited from RefBase
typedef boost::intrusive_ptr< RefBase > | Ptr
typedef boost::weak_ptr< RefBase > | WeakPtr

## Public Member Functions

iterator | begin ()
| Iterator to first element.
iterator | begin (const Box3i &subset)
| Iterator to first element of specific subset.
virtual void | clear (const Data_T &value)
| Clears all the voxels in the storage. Should be re-implemented by subclasses that can provide a more efficient version.
iterator | end ()
| Iterator pointing one element past the last valid one.
iterator | end (const Box3i &subset)
| Iterator pointing one element past the last valid one (for a subset).
virtual Data_T & | lvalue (int i, int j, int k)=0
| Write access to a voxel. The coordinates are global coordinates.
Public Member Functions inherited from Field< Data_T >
const_iterator | cbegin () const
| Const iterator to first element. "cbegin" matches the tr1 c++ standard.
const_iterator | cbegin (const Box3i &subset) const
| Const iterator to first element of specific subset.
const_iterator | cend () const
| Const iterator pointing one element past the last valid one.
const_iterator | cend (const Box3i &subset) const
| Const iterator pointing one element past the last valid one (for a subset).
virtual std::string | dataTypeString () const
virtual Data_T | value (int i, int j, int k) const =0
| Read access to a voxel. The coordinates are in integer voxel space .
virtual | ~Field ()
| Dtor.
Public Member Functions inherited from FieldRes
V3i const | dataResolution () const
const Box3i & | dataWindow () const
| Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field subclass.
const Box3i & | extents () const
| Returns the extents of the data. This signifies the relevant area that the data exists over. However, the data window (below) may be smaller than the extents, in which case it is only safe to call value() for those coordinate inside the data window.
| FieldRes ()
| This constructor ensures that we have a valid mapping at all times.
| FieldRes (const FieldRes &src)
| Base class copy constructor.
bool | isInBounds (int i, int j, int k) const
| Returns true is the indicies are in bounds of the data window.
FieldMapping::Ptr | mapping ()
| Returns a pointer to the mapping.
const FieldMapping::Ptr | mapping () const
| Returns a pointer to the mapping.
virtual void | mappingChanged ()
| Tells the subclass that the mapping changed.
virtual long long int | memSize () const
| Returns the memory usage (in bytes).
void | setMapping (FieldMapping::Ptr mapping)
| Sets the field's mapping.
virtual size_t | voxelCount () const
| Counts the number of voxels. For most fields, this is just the volume of the data window, but sparse data structures can override this to return a better value.
Public Member Functions inherited from FieldBase
| FieldBase ()
| Constructor.
| FieldBase (const FieldBase &)
| Copy Constructor.
virtual | ~FieldBase ()
| Destructor.
virtual std::string | className () const =0
| Returns the class name of the object. Used by the class pool and when writing the data to disk.
virtual std::string | classType () const =0
| Returns the full class type string.
virtual Ptr | clone () const =0
| Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
void | copyMetadata (const FieldBase &field)
| Copies the metadata from a second field.
Public Member Functions inherited from RefBase
void | ref () const
| Used by boost::intrusive_pointer.
size_t | refcnt ()
| Used by boost::intrusive_pointer.
void | unref () const
| Used by boost::intrusive_pointer.
WeakPtr | weakPtr () const
| RefBase ()
| RefBase (const RefBase &)
| Copy constructor.
RefBase & | operator= (const RefBase &)
| Assignment operator.
virtual | ~RefBase ()
| Destructor.
virtual bool | checkRTTI (const char *typenameStr)=0
| This function is only implemented by concrete classes and triggers the actual RTTI check through matchRTTI();.
bool | matchRTTI (const char *typenameStr)
| Performs a check to see if the given typename string matches this class' This needs to be implemented in -all- subclasses, even abstract ones.
Public Member Functions inherited from MetadataCallback
virtual void | metadataHasChanged (const std::string &)
| Alerts the callback holder that the metadata has changed.

## Static Public Member Functions

static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from Field< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldRes
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldBase
static const char * | staticClassName ()
static const char * | staticClassType ()
static const char * | staticClassType ()

## Public Attributes

| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from Field< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldRes
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldBase
std::string | attribute
| Optional name of the attribute the field represents.
std::string | name
| Optional name of the field.

## Private Types

typedef Field< Data_T > | base

## Static Private Attributes

static TemplatedFieldType< WritableField< Data_T > > | ms_classType

## Additional Inherited Members

Protected Types inherited from FieldRes
typedef MatrixFieldMapping | default_mapping
Protected Attributes inherited from FieldRes
Box3i | m_dataWindow
| Defines the area where data is allocated. This should be treated as a closed (i.e. inclusive) interval.
Box3i | m_extents
| Defines the extents of the the storage. This may be larger or smaller than the data window, and in the case where it is larger, care must be taken not to access voxels outside the data window. This should be treated as a closed (i.e. inclusive) interval.
FieldMapping::Ptr | m_mapping
| Pointer to the field's mapping.

## Detailed Description

template<class Data_T>
class WritableField< Data_T >

This class brings together both read- and write-access to voxels. The buffer can not be resized. Resizing is added by ResizableField.

Definition at line 623 of file Field.h.

## Member Typedef Documentation

## Ptr

template<class Data_T>

typedef boost::intrusive_ptr<WritableField> WritableField< Data_T >::Ptr

Definition at line 630 of file Field.h.

## class_type

template<class Data_T>

typedef WritableField<Data_T> WritableField< Data_T >::class_type

Definition at line 634 of file Field.h.

## base

template<class Data_T>

typedef Field<Data_T> WritableField< Data_T >::base

private

Definition at line 690 of file Field.h.

## Member Function Documentation

## staticClassName()

template<class Data_T>

const char * WritableField< Data_T >::staticClassName | ( |  | ) |

inline static

Definition at line 637 of file Field.h.

{
return "WritableField";
}

## staticClassType()

template<class Data_T>

const char * WritableField< Data_T >::staticClassType | ( |  | ) |

inline static

Definition at line 642 of file Field.h.

{
return WritableField<Data_T>::ms_classType.name();
}
FieldBase::name
std::string name
Optional name of the field.
Definition Field.h:171
WritableField
Definition Field.h:625

References ms_classType.

## begin() [1/2]

template<class Data_T>

WritableField< Data_T >::iterator WritableField< Data_T >::begin | ( |  | ) |

inline

Iterator to first element.

Definition at line 779 of file Field.h.

{
if (FieldRes::dataResolution() == V3i(0))
return end();
return iterator(*this, Field<Data_T>::m_dataWindow,
Field<Data_T>::m_dataWindow.min);
}
V3i
Imath::V3i V3i
Definition SpiMathLib.h:71
WritableField::iterator
Definition Field.h:704
WritableField::end
iterator end()
Iterator pointing one element past the last valid one.
Definition Field.h:802

References FieldRes::dataResolution(), end(), and FieldRes::m_dataWindow.

Referenced by clear(), ResizableField< Data_T >::copyFrom(), and ResizableField< Data_T >::copyFrom().

## begin() [2/2]

template<class Data_T>

WritableField< Data_T >::iterator WritableField< Data_T >::begin | ( | const Box3i & | subset | ) |

inline

Iterator to first element of specific subset.

Definition at line 791 of file Field.h.

{
if (subset.isEmpty())
return end(subset);
return iterator(*this, subset, subset.min);
}

References end().

## end() [1/2]

template<class Data_T>

WritableField< Data_T >::iterator WritableField< Data_T >::end | ( |  | ) |

inline

Iterator pointing one element past the last valid one.

Definition at line 802 of file Field.h.

{ return iterator(*this, Field<Data_T>::m_dataWindow,
V3i(Field<Data_T>::m_dataWindow.min.x,
Field<Data_T>::m_dataWindow.min.y,
Field<Data_T>::m_dataWindow.max.z + 1));
}

References FieldRes::m_dataWindow.

Referenced by begin(), begin(), clear(), ResizableField< Data_T >::copyFrom(), and ResizableField< Data_T >::copyFrom().

## end() [2/2]

template<class Data_T>

WritableField< Data_T >::iterator WritableField< Data_T >::end | ( | const Box3i & | subset | ) |

inline

Iterator pointing one element past the last valid one (for a subset).

Definition at line 813 of file Field.h.

{ return iterator(*this, subset,
V3i(subset.min.x, subset.min.y, subset.max.z + 1));
}

## lvalue()

template<class Data_T>

virtual Data_T & WritableField< Data_T >::lvalue | ( | int | i,
|  | int | j,
|  | int | k )

pure virtual

Write access to a voxel. The coordinates are global coordinates.

Note
  Before the internal storage is accessed, the subclass must compute the crop window coordinates by looking at Field::m_dataWindow.
  This is named differently from the const value so that non-const objects still have a clear way of accessing data in a const way.
  Virtual functions are known not to play nice with threading. Therefor, concrete classes can implement (by convention) fastLValue() as a non-virtual function.

Implemented in DenseField< Data_T >, DenseField< double >, DenseField< float >, DenseField< half >, DenseField< V3d >, DenseField< V3f >, DenseField< V3h >, EmptyField< Data_T >, EmptyField< float >, MACField< Data_T >, MACField< V3d >, MACField< V3f >, MACField< V3h >, Ptr< float >, real_t< Data_T >, SparseField< Data_T >, SparseField< double >, SparseField< float >, SparseField< half >, SparseField< V3d >, SparseField< V3f >, and SparseField< V3h >.

## clear()

template<class Data_T>

virtual void WritableField< Data_T >::clear | ( | const Data_T & | value | ) |

inline virtual

Clears all the voxels in the storage. Should be re-implemented by subclasses that can provide a more efficient version.

Reimplemented in DenseField< Data_T >, EmptyField< Data_T >, MACField< Data_T >, real_t< Data_T >, and SparseField< Data_T >.

Definition at line 679 of file Field.h.

{ std::fill(begin(), end(), value); }
Field::value
virtual Data_T value(int i, int j, int k) const =0
Read access to a voxel. The coordinates are in integer voxel space .
WritableField::begin
iterator begin()
Iterator to first element.
Definition Field.h:779

References begin(), end(), and Field< Data_T >::value().

## Member Data Documentation

## DEFINE_FIELD_RTTI_ABSTRACT_CLASS

template<class Data_T>

WritableField< Data_T >::DEFINE_FIELD_RTTI_ABSTRACT_CLASS

Definition at line 635 of file Field.h.

## ms_classType

template<class Data_T>

TemplatedFieldType<WritableField<Data_T> > WritableField< Data_T >::ms_classType

static private

Definition at line 686 of file Field.h.

Referenced by staticClassType().

The documentation for this class was generated from the following file:

- export/Field.h